InsightHub/InsightHub/Areas/Admin/Controllers/UsersController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using InsightHub.Data;
using InsightHub.Models;
using InsightHub.Services.Contracts;
using InsightHub.Web.Areas.Admin.Models;
using Microsoft.AspNetCore.Authorization;

namespace InsightHub.Web.Areas.Admin.Controllers
{
    /// <summary>
    /// Provides functionality to the /User/ route in the Admin area:
    ///   -  Displays all approved users index page
    ///    - Displays all pending users index page
    ///     - Displays action to approve a user
    ///      - Displays action to ban a user
    ///        - Displays action to get a user by ID
    ///         - Displays action to delete a user
    /// </summary>
    [Area("Admin")]
    [Authorize(Roles = "Admin")]
    public class UsersController : Controller
    {
        private readonly IUserService userService;

        public UsersController(IUserService userService)
        {
            this.userService = userService;
        }

        public async Task<IActionResult> Index()
        {
            if (User.IsInRole("Admin"))
            {
                var users = await this.userService.GetAllApprovedUsersAsync();
                var userViewModels = users.Select(u => new UserIndexViewModel(u));

                return View(userViewModels);
            }

            return RedirectToAction(nameof(Index), "Home");
        }

        // GET: Pending Users
        public async Task<IActionResult> Pending()
        {
            if (User.IsInRole("Admin"))
            {
                var users = await this.userService.GetAllPendingUsersAsync();
                var userViewModels = users.Select(u => new UserIndexViewModel(u));

                return View(userViewModels);
            }

            return RedirectToAction(nameof(Index), "Home");
        }

        // Post: Approve User
        public async Task<IActionResult> Approve(int id)
        {
            if (User.IsInRole("Admin"))
            {
                var user = await this.userService.ApproveUserAsync(id);

                return RedirectToAction(nameof(Index));
            }

            return RedirectToAction(nameof(Index), "Home");
        }

        // Post: Ban User
        public async Task<IActionResult> Ban(int Id)
        {
            if (User.IsInRole("Admin"))
            {
                var user = await this.userService.BanUserAsync(Id);
                var userViewModel = new UserIndexViewModel(user);

                return RedirectToAction(nameof(Pending));
            }

            return RedirectToAction(nameof(Index), "Home");
        }

        // GET: Users/Details/5
        public async Task<IActionResult> Details(int? id)
        {
            if (User.IsInRole("Admin"))
            {
                if (id == null)
                {
                    return NotFound();
                }

                var user = await this.userService.GetUserAsync(id);

                if (user == null)
                {
                    return NotFound();
                }

                var userViewModel = new UserViewModel(user);

                return View(userViewModel);
            }

            return RedirectToAction(nameof(Index), "Home");
            
        }

        // GET: Users/Delete/5
        public async Task<IActionResult> Delete(int? id)
        {
            if (User.IsInRole("Admin"))
            {
                if (id == null)
                {
                    return NotFound();
                }

                var user = await this.userService.GetUserAsync(id);

                if (user == null)
                {
                    return NotFound();
                }

                var userViewModel = new UserViewModel(user);

                return View(userViewModel);
            }

            return RedirectToAction(nameof(Index), "Home");
        }

        // POST: Users/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            if (User.IsInRole("Admin"))
            {
                var user = await this.userService.DeleteUserAsync(id);

                return RedirectToAction(nameof(Index));
            }

            return RedirectToAction(nameof(Index), "Home");
        }
    }
}

InsightHub/InsightHub/Controllers/ReportsController.cs
using InsightHub.Data;
using InsightHub.Services.Contracts;
using InsightHub.Services.Providers.Contracts;
using InsightHub.Web.Models;
using InsightHub.Web.Models.ReportMVCModels;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Linq;
using System.Threading.Tasks;

namespace InsightHub.Web.Controllers
{
    /// <summary>
    /// Provides functionality to the /Report/ route:
    ///   -  Displays a reports' index page
    ///    - Displays a reports' details page
    ///     - Displays a reports' download action
    /// </summary>
    public class ReportsController : Controller
    {
        private readonly InsightHubContext context;
        private readonly IReportService reportService;
        private readonly ITagService tagService;
        private readonly IIndustryService industryService;
        private readonly IUserService userService;
        private readonly IFileTypeProvider fileTypeProvider;

        public ReportsController(InsightHubContext context, IReportService reportService, 
            ITagService tagService, IIndustryService industryService, IUserService userService, IFileTypeProvider fileTypeProvider)
        {
            this.context = context;
            this.reportService = reportService;
            this.tagService = tagService;
            this.industryService = industryService;
            this.userService = userService;
            this.fileTypeProvider = fileTypeProvider;
        }

        // GET: Reports
        public async Task<IActionResult> Index()
        {
            var reports = await this.reportService.GetAllApprovedReportsAsync();
            
            var reportsViewModel = reports.Select(r => new IndexReportViewModel
            {
                Id = r.Id,
                Name = r.Name,
                Description = r.Description,
                Industry = new IndustryViewModel { Id = r.Industry.Id, Name = r.Industry.Name},
                Author = r.Author,
                Tags = r.Tags.Select(tag => new TagViewModel { Id = tag.Id, Name = tag.Name }).ToList(),
                CreatedOn = r.CreatedOn,
                TimesDownloaded = r.TimesDownloaded
            });

            return View(reportsViewModel);
        }

        // GET: Reports/Details/5
        public async Task<IActionResult> Details(int id)
        {
            try
            {
                var report = await this.reportService.GetReportAsync(id);

                var reportsViewModel = new DetailsMVCViewModel
                {
                    Id = report.Id,
                    Name = report.Name,
                    Description = report.Description,
                    Industry = new IndustryViewModel { Id = report.Industry.Id, Name = report.Industry.Name },
                    Author = report.Author,
                    Tags = report.Tags.Select(tag => new TagViewModel { Id = tag.Id, Name = tag.Name }).ToList(),
                    TimesDownloaded = report.TimesDownloaded,
                    FileName = report.FileName
                };

                if (report == null)
                {
                    return NotFound();
                }

                return View(reportsViewModel);
            }
            catch (Exception)
            {
                return NotFound();
            }

        }


        public async Task<IActionResult> DownloadFile(int id)
        {
            try
            {
                var userID = int.Parse(User.FindFirst(System.Security.Claims.ClaimTypes.NameIdentifier).Value);
                var report = await this.reportService.GetReportAsync(id);
                if (report == null)
                {
                    return BadRequest();
                }
                var memory = await this.reportService.DownloadReportAsync(id, userID);

                var ext = fileTypeProvider.GetFileType(report.FileName);

                return File(memory, ext, report.FileName);
            }
            catch (Exception)
            {
                return NotFound();
            }
        }

        
    }
}

InsightHub/InsightHub/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - InsightHub</title>
    <link href="~/css/site.css" rel="stylesheet" />
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <script src="//ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <link href="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/2.0.1/css/toastr.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/2.0.1/js/toastr.js"></script>
</head>
<body style="background-color: #2b3e50" class="text-dark mb-1">
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">InsightHub</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <partial name="_LoginPartial" />
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        @if (User.IsInRole("Admin"))
                        {
                            <li class="nav-item dropdown">
                                <a class="nav-link dropdown-toggle" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Users</a>
                                <div class="dropdown-menu">
                                    <a class="dropdown-item" asp-area="Admin" asp-controller="Users" asp-action="Index">Active Users</a>
                                    <a class="dropdown-item" asp-area="Admin" asp-controller="Users" asp-action="Pending">Pending Users</a>
                                </div>
                            </li>
                            <li class="nav-item dropdown">
                                <a class="nav-link dropdown-toggle" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Reports</a>
                                <div class="dropdown-menu" style="">
                                    <a class="dropdown-item" asp-area="Admin" asp-controller="Reports" asp-action="Index">Approved Reports</a>
                                    <a class="dropdown-item" asp-area="Admin" asp-controller="Reports" asp-action="Pending">Pending Reports</a>
                                </div>
                            </li>
                            <li class="nav-item dropdown">
                                <a class="nav-link dropdown-toggle" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Industries</a>
                                <div class="dropdown-menu" style="">
                                    <a class="dropdown-item" asp-area="Admin" asp-controller="Industries" asp-action="Create">Add Industry</a>
                                    <a class="dropdown-item" asp-area="Admin" asp-controller="Industries" asp-action="Index">All Industries</a>
                                </div>
                            </li>
                            <li class="nav-item dropdown">
                                <a class="nav-link dropdown-toggle" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Tags</a>
                                <div class="dropdown-menu" style="">
                                    <a class="dropdown-item" asp-area="Admin" asp-controller="Tags" asp-action="Create">Add Tag</a>
                                    <a class="dropdown-item" asp-area="Admin" asp-controller="Tags" asp-action="Index">All Tags</a>
                                </div>
                            </li>
                        }

                        @if (!User.IsInRole("Admin"))
                        {
                            <li class="nav-item dropdown">
                                <a class="nav-link dropdown-toggle" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Reports</a>
                                <div class="dropdown-menu" style="">

                                    @if (User.IsInRole("Author"))
                                    {
                                        <a class="dropdown-item" asp-area="Author" asp-controller="Reports" asp-action="Create">Create Report</a>
                                        <a class="dropdown-item" asp-area="Author" asp-controller="Reports" asp-action="ShowMyReports">My Reports</a>
                                    }
                                    @if (User.IsInRole("Author") || User.IsInRole("Client"))
                                    {
                                        <a class="dropdown-item" asp-area="Client" asp-controller="Reports" asp-action="Index">My Downloaded Reports</a>
                                    }
                                    <a class="dropdown-item" asp-area="" asp-controller="Reports" asp-action="Index">All Reports</a>
                                </div>
                            </li>
                            if (User.IsInRole("Client") || User.IsInRole("Author"))
                            {
                                <li class="nav-item dropdown">
                                    <a class="nav-link dropdown-toggle" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Industries</a>
                                    <div class="dropdown-menu" style="">
                                        <a class="dropdown-item" asp-area="Client" asp-controller="Industries" asp-action="Index">All Industries</a>
                                        <a class="dropdown-item" asp-area="Client" asp-controller="Industries" asp-action="Subscriptions">My Subscriptions</a>
                                    </div>
                                </li>
                            }
                        }
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>
    <footer class="border text-dark bg-white fixed-bottom">
        <div class="container">
            &copy; 2020 - InsightHub - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <link href="~/css/site.css" rel="stylesheet" />
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/bs4/dt-1.10.21/af-2.3.5/b-1.6.2/b-colvis-1.6.2/cr-1.5.2/fc-3.3.1/fh-3.1.7/kt-2.5.2/r-2.2.5/rg-1.1.2/rr-1.2.7/sc-2.0.2/sp-1.1.1/sl-1.3.1/datatables.min.css" />

    <script type="text/javascript" src="https://cdn.datatables.net/v/bs4/dt-1.10.21/af-2.3.5/b-1.6.2/b-colvis-1.6.2/cr-1.5.2/fc-3.3.1/fh-3.1.7/kt-2.5.2/r-2.2.5/rg-1.1.2/rr-1.2.7/sc-2.0.2/sp-1.1.1/sl-1.3.1/datatables.min.js"></script>

    @RenderSection("Styles", required: false)
    @RenderSection("Scripts", required: false)
</body>
</html>